/***************************************************************
*
*  (c) 2013 Slavistik-Portal (slavistik-portal@sbb.spk-berlin.de)
*
***************************************************************/
/**
 * Widget for Solr-Index of the Universitetskaja biblioteka online (UBO)
 * More information: https://slavistik-portal.de/anmeldung-ubo.html
 *
 * @author		Vladimir Neumann <vladimir.neumann@sbb.spk-berlin.de>
 * @date		January 2018
 * @version 	0.2
 *
 */
 
var totalRec = 0;   
var recPerPage = 10;
var recStart = 0;
var curPage = 1;
var onside = 6;
var filterQuery =[];

$(document).ready(function(){
	document.search.onsubmit = onFormSubmitEventHandler;

});
	   
// when search button pressed
function onFormSubmitEventHandler() 
{
    resetPage();
    triggerSearch();
    return false;
}	   
	   
function resetPage()
{
    curPage = 1;
    recStart = 0;
	document.getElementById('pager').innerHTML = '';
}
	   
function triggerSearch(){
	var event = 'FormSubmit';
	var query = $('#query').val();
	var url = 'https://slavistik-guide.de/widget/ubo/select?'
		+ 'q=' + encodeURIComponent(query) + '+OR+title:' + encodeURIComponent(query) + '^1.0'
		// + ' {!boost b=titel}'
		+ '&start=' + recStart
		+ '&rows=' + recPerPage
		+ '&wt=json&json.wrf=?'
		+ '&facet=true'
		+ '&facet.limit=30'
		+ '&facet.mincount=1'
		+ '&facet.field=su_f'
		+ '&fq='+getFacetQuery();
	//console.log(url);
	$.getJSON(url, processResult);
	
	// Stats 
	var device = 'UBO';
	if ( curPage > 1 ) { event = 'PageNum ' + curPage;}
	if ( !jQuery.isEmptyObject(filterQuery)) { event = "Facet: " + filterQuery.join();}
	$.get("https://slavistik-guide.de/widget/stats/track.php", { value: query, event: event, category: "Search", device: device, tmp: $.now() } );
}
			
function triggerSpell(){
	var query = $('#query').val();
	var url = 'https://slavistik-guide.de/widget/ubo/spell?'
		+ 'q=' + encodeURIComponent(query.toLowerCase(query))
		+ '&start=0'
		+ '&rows=0'
		+ '&wt=json&json.wrf=?'
		+ '&qt=spellchecker'
		+ '&spellcheck=true&spellcheck.extendedResults=false'
	//console.log(url);
	if (query != '') { $.getJSON(url, drawSpellcheck);}
}
			
function processResult(data){

	totalRec = data.response.numFound;
	document.getElementById('hits').innerHTML = '';
	document.getElementById('hits').innerHTML = 'Treffer: <b>' + totalRec + '</b>';
	document.getElementById('spell').innerHTML = '';
	document.getElementById('results').innerHTML = '';	
	
	if (totalRec > 0) {
	drawPager();
	 } else {
		 document.getElementById('pager').innerHTML = '';
		 document.getElementById('pager_down').innerHTML = '';
		 triggerSpell();
	 }

			
			var details ='';
			
			$.each(data.response.docs, function(key, value) {

			details += '<div class="details"><table class="table table-bordered table-striped"><colgroup width="120"></colgroup>';
			//console.log(value);
			
			if (value.title != undefined) {
				details += '<tr><td class ="rt">Titel</td><td><b>' + value.title + '</b>';
				details += '</td></tr>';
			}

			if (value.author != undefined) {
				details += '<tr><td class ="rt">Autor</td><td>' + value.author.join('; ');
				details += '</td></tr>';
			}			

			if (value.place != undefined) {
				details += '<tr><td class ="rt">Ort</td><td>' + value.place;
				details += '</td></tr>';
			}
			
			if (value.year != undefined) {
				details += '<tr><td class ="rt">Jahr</td><td>' + value.year;
				details += '</td></tr>';
			}			

			if (value.subject != undefined) {
				details += '<tr><td class ="rt">SW</td><td>' + value.subject.join('; ');
				details += '</td></tr>';
			}
			
			if (value.classification != undefined) {
				details += '<tr><td class ="rt">Klassif.</td><td>' + value.classification.join('; ');
				details += '</td></tr>';
			}

			if (value.pages != undefined) {
				details += '<tr><td class ="rt">Seiten</td><td>' + value.pages;
				details += '</td></tr>';
			}

			if (value.medium != undefined) {
				details += '<tr><td class ="rt">Medium</td><td>' + value.medium;
				details += '</td></tr>';
			}
			
			if (value.url != undefined) {	
				details += '<tr><td class ="rt">URL</td><td><a href="'+ value.url + '" target="_blank">URL</a>';
				details += '</td></tr>';				
			}

			if (value.id != undefined) {	
				details += '<tr><td class ="rt">URL</td><td><a href="http://biblioclub.ru.772078319.erf.sbb.spk-berlin.de/index.php?page=book&id='+ value.id + '" target="_blank">Zugriff über die FID-Lizenz</a><br><font size="1"><a href="http://slavistik-portal.de/anmeldung-ubo.html" target="_blank">[Zugang hier beantragen]</a></font>';
				details += '</td></tr>';				
			}			
			


			
			  details += '</table></div><br>';
			

			});
			
			document.getElementById('results').innerHTML = details;			
			drawFacets(data, 'su_f', 'Schlagwörter', '1');
		
}
		
function drawFacets(data, name_f, title_f, order_f){

			document.getElementById('facets_'+order_f).innerHTML = '';	
			var facets ='';
			
			$.each(data.facet_counts, function(key, value) {
			//console.log(value);
			
			if (value[name_f] != undefined && value[name_f].length != 0) {
			facets += '<p class="facets_t">'+ title_f +'</p>';
			  for (fnum = 0; fnum < value[name_f].length; fnum++) {
			  facets += '<div class="facetitem">';
			  
			  if (jQuery.inArray(value[name_f][fnum], filterQuery) != '-1') {	
				  facets += '<a href="#" class="crossout" '+name_f+'="' + value[name_f][fnum] + '" onclick="defilterFacet(this.getAttribute(\''+name_f+'\'));return false;">' + value[name_f][fnum] + '</a>';
					fnum++;
				  facets += " <span>" + value[name_f][fnum] + "</span> [<strong style=\"color: red;\">Filter</strong>]";
			  } else {
				  facets += '<a href="#" '+name_f+'="' + value[name_f][fnum] + '" onclick="filterFacet(this.getAttribute(\''+name_f+'\'));return false;">' + value[name_f][fnum] + '</a>';
					fnum++;
				  facets += " <span>" + value[name_f][fnum] + "</span>";			  
			  }
			  
			  facets += '</div>';
			  }
			  
			}
			
			
			document.getElementById('facets_'+order_f).innerHTML = facets;
			
			});
}

function drawSpellcheck(data){

			document.getElementById('spell').innerHTML = '';
			var spell ='';
			
			if (data.spellcheck != undefined) {
				$.each(data.spellcheck.suggestions, function(key, value) {
				
				//console.log(value);
				
				if (value.suggestion != undefined) {
				
				var suggestionItems = '';
					for (var i = 0; i < value.suggestion.length; ++i) {
					suggestionItems += '<a href="#" suggestionItem_id="' + value.suggestion[i] + '" onclick="suggestionToQuery(this.getAttribute(\'suggestionItem_id\'));return false;">' + value.suggestion[i] + '</a> ';
						}
				  spell += 'Do you mean: ' + suggestionItems + ' ?';
					  
				}
				
				document.getElementById('spell').innerHTML = spell;

				
				});
			}
}

function suggestionToQuery(value){
	document.search.query.value = value;
	triggerSearch();
}
			
function showPage(i){
	curPage = i;
	recStart = (i - 1)*recPerPage;
	triggerSearch();
}
		
function pagerNext(i){
	curPage = i;
	recStart = i*recPerPage;
	triggerSearch();
}

function filterFacet(value){
	filterQuery.push(value);
	curPage = 1;
	recStart = 0;
	triggerSearch();
}

function defilterFacet(value){
	filterQuery.splice(jQuery.inArray(value,filterQuery), 1);
	curPage = 1;
	recStart = 0;
	triggerSearch();
}

function getFacetQuery(){
	if (filterQuery.length > 0) {
		var filterQueryURL = '';
		for (var i = 0; i < filterQuery.length; ++i) {
		filterQueryURL	+= '"' + encodeURIComponent(filterQuery[i]) + '"+';
		}
		return filterQueryURL;
	} else {
	return '';
	}
}
		
function drawPager(){

		document.getElementById('pager').innerHTML = '';
		document.getElementById('pager_down').innerHTML = '';
		var pager ='';
		var numLabel ='';
		var pages = Math.ceil(totalRec / recPerPage);
			pager = '<nav><ul class="pagination">';
			if ((curPage - onside) < 1 ) { is = 1;} else {is = (curPage - onside);}
			
			if ((curPage - onside) > 1) {
				pager += '<li><a href="#" id="next" onclick="pagerNext('+(curPage - 1)+')">«</a><li>';
			}
				
			for(var i = is ; i <= pages && i <= (curPage + onside); i++) {
			if(i == curPage) {numLabel = " class=\"active\"";}
				
			pager += '<li' + numLabel + '><a href="#" onclick="showPage('+i+')">' + i + '</a></li>';
			var numLabel ='';
			}
			
			if (pages - (curPage + onside) > 0) {
				pager += '<li><a href="#" id="next" onclick="pagerNext('+(curPage + 1)+')">»</a></li>';
			}

				
			pager += '</ul></nav>';
			
			if (totalRec > 5) {	
			document.getElementById('pager').innerHTML = pager;
			if (totalRec - recStart > 5) { document.getElementById('pager_down').innerHTML = pager; }
			}
		    
			//console.log(pages);		
}